#include <bits/stdc++.h>

using namespace std;

#ifdef TEST
#   define DEBUG(x) cout << x << endl
#else
#   define DEBUG(x)
#endif

unordered_map<int, int> res;
vector<int> coins;

void init(const vector<int>& coins) {
    ::coins = coins;
    res.clear();
}

// memoization
int solve(int x) {
    if(x < 0) return INT_MAX;
    if(x == 0) return 0;
    if(res.find(x) == res.end()) {
        DEBUG("Computing result for " << x);
        int best = INT_MAX;
        for(auto c : coins) best = min(best, solve(x - c));
        res[x] = 1 + best;
    }
    return res[x];
}

// iterative
void solution(const vector<int>& coins, int x) {
    int res[x+1] = {0};
    int first_coin[x+1];
    for(int i = 1; i <= x; i++) {
        res[i] = INT_MAX;
        for(auto c : coins) {
            if(i - c >= 0 && 1 + res[i - c] < res[i]) {
                res[i] = 1 + res[i - c];
                first_coin[i] = c;
            }
        }
    }
    
    // print the solution
    cout << first_coin[x];
    for(;;) {
        x -= first_coin[x];
        if(x <= 0) break;
        cout << " + " << first_coin[x];
    }
    cout << endl;
}

int count_solutions(const vector<int>& coins, int x) {
    int res[x+1] = {1};
    for(int i = 1; i <= x; i++) {
        for(auto c : coins) {
            if(i - c >= 0) res[i] += res[i - c];
        }
    }
    return res[x];
}

int main() {
    init({1, 2, 5, 10, 20, 50, 100, 200});
    cout << solve(520) << endl;
    
    init({1, 3, 4});
    cout << solve(6) << endl;

    solution({1, 3, 4}, 6);
    
    cout << count_solutions({1, 3, 4}, 6) << endl;
    
    return 0;
}

